// Define a special variation of an FBox, which has the same
// physical behaviour as a rectangle but that renders itself
// using an image of an iClicker.  This uses object-oriented
// programming techniques, and you really don't need to 
// understand that right now.  In fact, you can ignore this
// file completely, unless you're really interested in learning
// more about his OO programming works ahead of time.

class FClicker
  extends FBox
{
  PImage img;
  float desired_width;
  
  FClicker( float desired_width )
  {
    super( 10, 10 );
    img = loadImage( "clicker.png" );
    this.desired_width = desired_width;
    float fac = desired_width / img.width;
    float dh = fac * img.height;
    
    setWidth( desired_width );
    setHeight( dh );
  }
  
  // Override the draw method to draw an image instead of
  // a rectangle.
  void draw( PGraphics applet )
  {
    float fac = desired_width / img.width;
    float dh = fac * img.height;
    
    preDraw( applet );
    image( img, -desired_width/2, -dh/2, desired_width, dh );
    postDraw( applet );
  }
}
